Test with Coverage:
  stage: CodeQuality
  image: golang:1.16-alpine
  needs: []
  rules:
    - if: $CI_COMMIT_TAG
      when: never
    - if: '$CI_COMMIT_TITLE =~ /^hot-fix.*/'
      when: never
    - if: '$TEST_DISABLED == "true"'
      when: never
    - when: always
  allow_failure: true
  services:
    - name: postgres:latest
      alias: postgres
  script:
    - export APP_ENV=test
    - export DATABASE_URL="postgres://${POSTGRES_USER}:${POSTGRES_PASSWORD}@postgres:5432/${POSTGRES_DB}"
    - export CGO_ENABLED=0
    - echo '' > .env
    - go test -timeout 60s -p 1 $(go list ./... | grep -v "/runners") -cover -coverprofile=coverage.out
  artifacts:
    when: always
    paths:
      - coverage.out
    reports:
      codequality: coverage.out

Test with Report:
  stage: CodeQuality
  image: golang:1.16-alpine
  needs: []
  rules:
    - if: $CI_COMMIT_TAG
      when: never
    - if: '$CI_COMMIT_TITLE =~ /^hot-fix.*/'
      when: never
    - if: '$TEST_DISABLED == "true"'
      when: never
    - when: always
  allow_failure: true
  services:
    - name: postgres:latest
      alias: postgres
  script:
    - export APP_ENV=test
    - export DATABASE_URL="postgres://${POSTGRES_USER}:${POSTGRES_PASSWORD}@postgres:5432/${POSTGRES_DB}"
    - export CGO_ENABLED=0
    - export ALLURE_RESULTS_PATH=${PWD}
    - echo '' > .env
    - go test -timeout 60s -p 1 $(go list ./... | grep -v "/runners") -json | tee test-report.out
  artifacts:
    when: always
    paths:
      - test-report.out
      - ./allure-results

Test with JUnit report:
  stage: CodeQuality
  image: golang:1.16-alpine
  needs: []
  rules:
    - if: $CI_COMMIT_TAG
      when: never
    - if: '$CI_COMMIT_TITLE =~ /^hot-fix.*/'
      when: never
    - if: '$TEST_DISABLED == "true"'
      when: never
    - when: always
  allow_failure: true
  services:
    - name: postgres:latest
      alias: postgres
  script:
    - export APP_ENV=test
    - export DATABASE_URL="postgres://${POSTGRES_USER}:${POSTGRES_PASSWORD}@postgres:5432/${POSTGRES_DB}"
    - export CGO_ENABLED=0
    - echo '' > .env
    - go get -u github.com/jstemmer/go-junit-report
    - go test -v -timeout 60s -p 1 $(go list ./... | grep -v "/runners") | go-junit-report -set-exit-code > report.xml
  artifacts:
    when: always
    reports:
      junit: report.xml

Build test:
  stage: CodeQuality
  image: golang:1.16-alpine
  needs: []
  rules:
    - if: '$TEST_DISABLED == "true"'
      when: never
    - if: '$CI_COMMIT_TITLE =~ /^hot-fix.*/'
      when: never
    - if: '$CI_COMMIT_BRANCH == "master"'
  allow_failure: true
  script:
    - go build -o /tmp/app ./cmd/app
    - go build -o /tmp/migration ./cmd/migration
    - go build -o /tmp/worker ./cmd/worker
